# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt
# $Id: container.py 14316 2009-01-23 15:12:55Z zagy $

import grok

import gocept.directory.interfaces


class Container(grok.Container):
    """Base container."""

    grok.baseclass()

    def sorted_values(self):
        return sorted(
            self.values(), key=lambda x: gocept.directory.interfaces.ITitle(x))

    def clear(self):
        for key in list(self.keys()):
            del self[key]


# CAUTION: the following template dir has to be set in views using the
# ContainerView
# grok.templatedir('containertemplates')

class ContainerView(grok.View):

    grok.baseclass()
    grok.template('container_list')

    def values(self):
        for obj in self.context.sorted_values():
            yield dict(title=gocept.directory.interfaces.ITitle(obj),
                       url=self.url(obj))
