# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt

import grok
import zope.component
import zope.dublincore.interfaces

import gocept.directory.interfaces
import gocept.directory.container
import gocept.directory.form
import gocept.directory.unixaccount
import gocept.directory.useraccount


class UnixAccounts(gocept.directory.container.Container):

    grok.implements(gocept.directory.interfaces.IUnixAccounts)


grok.templatedir('containertemplates')

class Index(gocept.directory.container.ContainerView):
    pass


@grok.subscribe(UnixAccounts, grok.IObjectAddedEvent)
def set_title(unixaccounts, event):
    dc = zope.dublincore.interfaces.IDCDescriptiveProperties(unixaccounts)
    dc.title = u'Unix Accounts'


class AddUserAccount(gocept.directory.form.BasicAddForm):

    factory = gocept.directory.useraccount.UserAccount

    form_fields = grok.Fields(
        gocept.directory.useraccount.IUserAccountAdding,
        grok.Fields(gocept.directory.interfaces.IUserAccount,
                    omit_readonly=True))


@grok.subscribe(gocept.directory.interfaces.IUnixAccount,
                grok.IObjectAddedEvent)
def allocate_uid(unixaccount, event):
    uids = zope.component.getUtility(gocept.directory.interfaces.IPOSIXIds,
                                     name='uid')
    unixaccount.uid = uids.register(unixaccount)


@grok.subscribe(gocept.directory.interfaces.IUnixAccount,
                grok.IObjectAddedEvent)
def set_owner(unixaccount, event):
    assert unixaccount.owner.unixaccount is None
    unixaccount.owner.unixaccount = unixaccount
